SystemOrganization addCategory: #'Rizel-SMark'!
SystemOrganization addCategory: #'Rizel-SMark-Tests'!

SMarkTimer subclass: #RizelTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelTimer class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 09:55'!
numberOfCalls
	<primitive: 'primGetMessagesSent' module: ''>
	
	^ self primitiveFailed ! !

!RizelTimer class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 09:55'!
resetNumberOfCalls
	<primitive: 'primResetMessagesSent' module: ''>
	
	^ self primitiveFailed ! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 07:00'!
numberOfCalls
	^ self class numberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:49'!
reset
	startTime := 0.
	elapsedTime := 0.
	self class resetNumberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:48'!
start
	startTime := self numberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:52'!
stop
	| elapsedInThisPeriod current |
	current := self numberOfCalls.
	elapsedInThisPeriod := current - startTime.
	elapsedTime := elapsedTime + elapsedInThisPeriod.! !

CommandLineHandler subclass: #RizelCommandLineHandler
	instanceVariableNames: 'packageMatching smarkSuites reporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelCommandLineHandler class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:28'!
commandName
	^ 'rizel'! !

!RizelCommandLineHandler class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:12'!
description
	^ 'run benchmarks'! !

!RizelCommandLineHandler methodsFor: 'activation' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:04'!
activate
	self activateHelp.
	self loadPackageMatching.
	self loadSuites.
	self loadReporter.
	self executeBenchMarks.
	self exitSuccess.! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:34'!
errorNoPackagesMatchingFound
	" "
	self exitFailure: 'No Packages Matching Found'! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:00'!
executeBenchMarks
	
	smarkSuites do: [ :suite |	 
			(RizelRunner execute: (suite new)) reportOn: (self stdout) using: reporter ].! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 10:15'!
loadPackageMatching
	|packageMatchingOption|
	
	packageMatchingOption := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--packagesMatching='  caseSensitive: false. ] 
			ifNone: [ self errorNoPackagesMatchingFound. ].
	
	packageMatching := (packageMatchingOption subStrings: '=') second.
	! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:04'!
loadReporter
	|suiteNames suiteParam|
	
	suiteParam := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--reporter='  caseSensitive: false. ] 
			ifNone: [nil].

	reporter := suiteParam ifNil:[ RizelSimpleReporter					
							] ifNotNil: [ (Smalltalk at: ((suiteParam subStrings: '=' ) second asSymbol)) ].! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 11:55'!
loadSuites
	|suiteNames suiteParam|
	
	suiteParam := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--suites='  caseSensitive: false. ] 
			ifNone: [nil].
	
	smarkSuites := suiteParam ifNil:[ SMarkSuite allSubclasses select: [ :cls | packageMatching match: (cls  class package name asString)].						
								] ifNotNil: [ 
								((suiteParam subStrings: '=' ) second subStrings:',') collect:[ :sn | (Smalltalk at: (sn asSymbol)) ]. ].! !

SMarkSuite subclass: #RzMarkTestScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark-Tests'!

!RzMarkTestScenario methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 07:00'!
benchBasic
	""
	(RSMP3File named:'MP3A' size:10) open.! !

SMarkReporter subclass: #RizelCSVReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelCSVReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:08'!
report

	runner results keysAndValuesDo: [:key :value |
		self reportAllRuns: value of: key.
	].

	^ self! !

!RizelCSVReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:22'!
reportAllRuns: aListOfResults of: benchmark
	
	stream << 'name, nom';cr.
	
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ', ' << (timer totalTime asString); cr.]]! !

SMarkReporter subclass: #RizelSimpleReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelSimpleReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:22'!
reportAllRuns: aListOfResults of: benchmark
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ': ' << (timer totalTime asString, ' nom'); cr.]]! !

SMarkRunner subclass: #RizelRunner
	instanceVariableNames: 'warmingUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelRunner class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 07:04'!
defaultTimer
	^ RizelTimer! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:41'!
initialize
	super initialize.
	warmingUp := false.! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:41'!
performBenchmark: aSelector
	"Based on an email by Eliot from May 16th, 2011.
	 The first time a method is executed it will get into the inline cache.
	 The second time, it is found in the inline cache, which triggers the JIT compiler to produce code.
	 Thus, the third time it should be executed in the steady state."
	warmingUp := true.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
	warmingUp := false.
	
	^ super performBenchmark: aSelector.! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:42'!
recordResults: timer for: aSelector
	"Only record the results when we are not in warmup mode."
	warmingUp ifFalse: [
		super recordResults: timer for: aSelector.
	].! !

!RizelRunner methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 11:37'!
reportOn: aStream
	RizelSimpleReporter reportFor: self on: aStream  
	! !

!RizelRunner methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 11:51'!
reportOn: aStream using: reporterClass
	reporterClass reportFor: self on: aStream  
	! !
